/*
 * generated by Xtext 2.22.0
 */
package tdt4250.ra.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import tdt4250.ra.ide.contentassist.antlr.internal.InternalRaxParser;
import tdt4250.ra.services.RaxGrammarAccess;

public class RaxParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(RaxGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, RaxGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getID_OR_STRINGAccess().getAlternatives(), "rule__ID_OR_STRING__Alternatives");
			builder.put(grammarAccess.getDepartmentAccess().getGroup(), "rule__Department__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup(), "rule__Course__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_3(), "rule__Course__Group_3__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_3_2(), "rule__Course__Group_3_2__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup(), "rule__ResourceAllocation__Group__0");
			builder.put(grammarAccess.getFactorAccess().getGroup(), "rule__Factor__Group__0");
			builder.put(grammarAccess.getRoleAccess().getGroup(), "rule__Role__Group__0");
			builder.put(grammarAccess.getDepartmentAccess().getShortNameAssignment_0(), "rule__Department__ShortNameAssignment_0");
			builder.put(grammarAccess.getDepartmentAccess().getNameAssignment_2(), "rule__Department__NameAssignment_2");
			builder.put(grammarAccess.getDepartmentAccess().getStaffAssignment_4(), "rule__Department__StaffAssignment_4");
			builder.put(grammarAccess.getDepartmentAccess().getCoursesAssignment_6(), "rule__Department__CoursesAssignment_6");
			builder.put(grammarAccess.getCourseAccess().getCodeAssignment_0(), "rule__Course__CodeAssignment_0");
			builder.put(grammarAccess.getCourseAccess().getNameAssignment_2(), "rule__Course__NameAssignment_2");
			builder.put(grammarAccess.getCourseAccess().getRolesAssignment_3_1(), "rule__Course__RolesAssignment_3_1");
			builder.put(grammarAccess.getCourseAccess().getRolesAssignment_3_2_1(), "rule__Course__RolesAssignment_3_2_1");
			builder.put(grammarAccess.getCourseAccess().getResourceAllocationsAssignment_3_4(), "rule__Course__ResourceAllocationsAssignment_3_4");
			builder.put(grammarAccess.getResourceAllocationAccess().getPersonAssignment_0(), "rule__ResourceAllocation__PersonAssignment_0");
			builder.put(grammarAccess.getResourceAllocationAccess().getFactorAssignment_2(), "rule__ResourceAllocation__FactorAssignment_2");
			builder.put(grammarAccess.getResourceAllocationAccess().getRoleAssignment_4(), "rule__ResourceAllocation__RoleAssignment_4");
			builder.put(grammarAccess.getRoleAccess().getNameAssignment_0(), "rule__Role__NameAssignment_0");
			builder.put(grammarAccess.getRoleAccess().getFactorAssignment_2(), "rule__Role__FactorAssignment_2");
			builder.put(grammarAccess.getPersonAccess().getNameAssignment(), "rule__Person__NameAssignment");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private RaxGrammarAccess grammarAccess;

	@Override
	protected InternalRaxParser createParser() {
		InternalRaxParser result = new InternalRaxParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public RaxGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(RaxGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
